package dev.fyloz.colorrecipesexplorer.dtos

import dev.fyloz.colorrecipesexplorer.Constants
import org.springframework.web.multipart.MultipartFile
import javax.validation.constraints.Min
import javax.validation.constraints.NotBlank

data class MaterialDto(
    override val id: Long = 0L,

    val name: String,

    val inventoryQuantity: Float,

    val isMixType: Boolean,

    val materialType: MaterialTypeDto,

    val simdutUrl: String? = null
) : EntityDto

data class MaterialSaveDto(
    override val id: Long = 0L,

    @field:NotBlank
    val name: String,

    @field:Min(0, message = Constants.ValidationMessages.SIZE_GREATER_OR_EQUALS_ZERO)
    val inventoryQuantity: Float,

    val materialTypeId: Long,

    val simdutFile: MultipartFile?
) : EntityDto

data class MaterialQuantityDto(
    val materialId: Long,

    @field:Min(0, message = Constants.ValidationMessages.SIZE_GREATER_OR_EQUALS_ZERO)
    val quantity: Float
)