package dev.fyloz.colorrecipesexplorer.dtos

import dev.fyloz.colorrecipesexplorer.Constants
import javax.validation.constraints.Min

data class MixMaterialDto(
    override val id: Long = 0L,

    val material: MaterialDto,

    val quantity: Float,

    val position: Int
) : EntityDto

data class MixMaterialSaveDto(
    override val id: Long = 0L,

    val materialId: Long,

    @field:Min(0, message = Constants.ValidationMessages.SIZE_GREATER_OR_EQUALS_ZERO)
    val quantity: Float,

    val position: Int
) : EntityDto