package dev.fyloz.colorrecipesexplorer.model

import dev.fyloz.colorrecipesexplorer.dtos.MixMaterialDto
import javax.persistence.*

@Entity
@Table(name = "mix_material")
data class MixMaterial(
    @Id
    @GeneratedValue(strategy = GenerationType.IDENTITY)
    override val id: Long?,

    @ManyToOne
    @JoinColumn(name = "material_id")
    val material: Material,

    var quantity: Float,

    var position: Int
) : ModelEntity

// ==== DSL ====
fun mixMaterial(
    id: Long? = null,
    material: Material = material(),
    quantity: Float = 0f,
    position: Int = 0,
    op: MixMaterial.() -> Unit = {}
) = MixMaterial(id, material, quantity, position).apply(op)

@Deprecated("Temporary DSL for transition")
fun mixMaterialDto(
    entity: MixMaterial
) = MixMaterialDto(entity.id!!, materialDto(entity.material), entity.quantity, entity.position)

@Deprecated("Temporary DSL for transition")
fun mixMaterial(
    dto: MixMaterialDto
) = MixMaterial(dto.id, material(dto.material), dto.quantity, dto.position)